Index: /anuga_core/source/anuga/abstract_2d_finite_volumes/pmesh2domain.py
===================================================================
--- /anuga_core/source/anuga/abstract_2d_finite_volumes/pmesh2domain.py	(revision 7736)
+++ /anuga_core/source/anuga/abstract_2d_finite_volumes/pmesh2domain.py	(revision 7737)
@@ -11,51 +11,13 @@
 
 
-##
-# @brief Convert a pmesh instance to a domain instance.
-# @param mesh The pmesh instance to convert.
-# @param DomainClass The class to instantiate and return.
-# @return The converted pmesh instance (as a 'DomainClass' instance).
-def pmesh_instance_to_domain_instance(mesh, DomainClass):
-    """Convert a pmesh instance/object into a domain instance.
-
-    Uses pmesh_to_domain_instance to convert a mesh file to a domain instance.
-    """
-
-    (vertex_coordinates, vertices, tag_dict, vertex_quantity_dict,
-     tagged_elements_dict, geo_reference) = pmesh_to_domain(mesh_instance=mesh)
-
-    # NOTE(Ole): This import cannot be at the module level
-    #            due to mutual dependency with domain.py
-    from anuga.abstract_2d_finite_volumes.domain import Domain
-
-    # ensure that the required 'DomainClass' actually is an instance of Domain
-    msg = ('The class %s is not a subclass of the generic domain class %s'
-           % (DomainClass, Domain))
-    assert issubclass(DomainClass, Domain), msg
-
-    # instantiate the result class
-    result = DomainClass(coordinates=vertex_coordinates,
-                         vertices=vertices,
-                         boundary=tag_dict,
-                         tagged_elements=tagged_elements_dict,
-                         geo_reference=geo_reference)
-
-    # set the water stage to be the elevation
-    if (vertex_quantity_dict.has_key('elevation') and
-        not vertex_quantity_dict.has_key('stage')):
-        vertex_quantity_dict['stage'] = vertex_quantity_dict['elevation']
-    result.set_quantity_vertices_dict(vertex_quantity_dict)
-
-    return result
-
 
 ##
 # @brief Convert a mesh file to a Domain instance.
-# @param file_name Name of the file to convert (TSH or MSH).
+# @param source Name of the file to convert (TSH or MSH), or a mesh.
 # @param DomainClass Class of return instance.
 # @param use_cache True if caching is to be used.
 # @param verbose True if this function is to be verbose.
 # @return An instance of 'DomainClass' containing the file data.
-def pmesh_to_domain_instance(file_name, DomainClass, use_cache=False,
+def pmesh_to_domain_instance(source, DomainClass, use_cache=False,
                              verbose=False):
     """Converts a mesh file(.tsh or .msh), to a Domain instance.
@@ -71,8 +33,8 @@
     if use_cache is True:
         from caching import cache
-        result = cache(_pmesh_to_domain_instance, (file_name, DomainClass),
+        result = cache(_pmesh_to_domain_instance, (source, DomainClass),
                        dependencies=[file_name], verbose=verbose)
     else:
-        result = apply(_pmesh_to_domain_instance, (file_name, DomainClass))        
+        result = apply(_pmesh_to_domain_instance, (source, DomainClass))        
         
     return result
@@ -84,21 +46,24 @@
 # @param DomainClass Class of return instance.
 # @return The DomainClass instance containing the file data.
-def _pmesh_to_domain_instance(file_name, DomainClass):
+def _pmesh_to_domain_instance(source, DomainClass):
     """Converts a mesh file(.tsh or .msh), to a Domain instance.
 
     Internal function. See public interface pmesh_to_domain_instance for details
     """
-    
-    (vertex_coordinates, vertices, tag_dict, vertex_quantity_dict,
-     tagged_elements_dict, geo_reference) = pmesh_to_domain(file_name=file_name)
-
-    # NOTE(Ole): This import cannot be at the module level due to mutual
-    # dependency with domain.py
-    from anuga.abstract_2d_finite_volumes.domain import Domain
+
+    from anuga.abstract_2d_finite_volumes.generic_domain import Generic_Domain 
 
     # ensure the required class is a subclass of Domain
     msg = ('The class %s is not a subclass of the generic domain class %s'
-           % (DomainClass, Domain))
-    assert issubclass(DomainClass, Domain), msg
+           % (DomainClass, Generic_Domain))
+    assert issubclass(DomainClass, Generic_Domain), msg
+
+    if type(source).__name__ == 'str':
+        parm = {'file_name': source}
+    else:
+        parm = {'mesh_instance': source}  
+
+    (vertex_coordinates, vertices, tag_dict, vertex_quantity_dict,
+     tagged_elements_dict, geo_reference) = pmesh_to_domain(**parm)
 
     domain = DomainClass(coordinates = vertex_coordinates,
Index: /anuga_core/source/anuga/abstract_2d_finite_volumes/quantity.py
===================================================================
--- /anuga_core/source/anuga/abstract_2d_finite_volumes/quantity.py	(revision 7736)
+++ /anuga_core/source/anuga/abstract_2d_finite_volumes/quantity.py	(revision 7737)
@@ -40,9 +40,11 @@
     # @param vertex_values ??
     def __init__(self, domain, vertex_values=None):
-        from anuga.abstract_2d_finite_volumes.domain import Domain
-
-        msg = ('First argument in Quantity.__init__() must be of class Domain '
-               '(or a subclass thereof). I got %s.' % str(domain.__class__))
-        assert isinstance(domain, Domain), msg
+        from anuga.abstract_2d_finite_volumes.generic_domain \
+                            import Generic_Domain
+
+        msg = ('First argument in Quantity.__init__() must be of class %s '
+               '(or a subclass thereof). I got %s.' 
+               % (str(Generic_Domain.__name__),str(domain.__class__)))
+        assert isinstance(domain, Generic_Domain), msg
 
         if vertex_values is None:
Index: /anuga_core/source/anuga/abstract_2d_finite_volumes/test_domain.py
===================================================================
--- /anuga_core/source/anuga/abstract_2d_finite_volumes/test_domain.py	(revision 7736)
+++ /anuga_core/source/anuga/abstract_2d_finite_volumes/test_domain.py	(revision 7737)
@@ -4,5 +4,5 @@
 from math import sqrt
 
-from anuga.abstract_2d_finite_volumes.domain import *
+from anuga.abstract_2d_finite_volumes.generic_domain import *
 from anuga.pmesh.mesh_interface import create_mesh_from_regions
 from anuga.config import epsilon
@@ -18,19 +18,4 @@
 
 
-def set_bottom_friction(tag, elements, domain):
-    if tag == "bottom":
-        domain.set_quantity('friction', 0.09, indices = elements)
-
-def set_top_friction(tag, elements, domain):
-    if tag == "top":
-        domain.set_quantity('friction', 1., indices = elements)
-
-
-def set_all_friction(tag, elements, domain):
-    if tag == 'all':
-        new_values = domain.get_quantity('friction').get_values(indices = elements) + 10.0
-
-        domain.set_quantity('friction', new_values, indices = elements)
-
 
 class Test_Domain(unittest.TestCase):
@@ -60,5 +45,5 @@
         other_quantities = ['elevation', 'friction']
 
-        domain = Domain(points, vertices, None,
+        domain = Generic_Domain(points, vertices, None,
                         conserved_quantities, evolved_quantities, other_quantities)
         domain.check_integrity()
@@ -89,5 +74,5 @@
         other_quantities = ['elevation', 'friction']
 
-        domain = Domain(points, vertices, None,
+        domain = Generic_Domain(points, vertices, None,
                         conserved_quantities, evolved_quantities, other_quantities)
 
@@ -126,5 +111,5 @@
         vertices = [ [1,0,2], [1,2,4], [4,2,5], [3,1,4]]
 
-        domain = Domain(points, vertices, boundary=None,
+        domain = Generic_Domain(points, vertices, boundary=None,
                         conserved_quantities =\
                         ['stage', 'xmomentum', 'ymomentum'])
@@ -200,5 +185,5 @@
         vertices = [ [1,0,2], [1,2,4], [4,2,5], [3,1,4]]
 
-        domain = Domain(points, vertices, boundary=None,
+        domain = Generic_Domain(points, vertices, boundary=None,
                         conserved_quantities =\
                         ['stage', 'xmomentum', 'ymomentum'],
@@ -254,5 +239,5 @@
 
 
-        domain = Domain(points, vertices, boundary=None,
+        domain = Generic_Domain(points, vertices, boundary=None,
                         conserved_quantities =\
                         ['stage', 'xmomentum', 'ymomentum'],
@@ -330,5 +315,5 @@
         vertices = [ [1,0,2], [1,2,4], [4,2,5], [3,1,4]]
 
-        domain = Domain(points, vertices, boundary=None,
+        domain = Generic_Domain(points, vertices, boundary=None,
                         conserved_quantities =\
                         ['stage', 'xmomentum', 'ymomentum'],
@@ -384,5 +369,5 @@
         vertices = [ [1,0,2], [1,2,4], [4,2,5], [3,1,4]]
 
-        domain = Domain(points, vertices, boundary=None,
+        domain = Generic_Domain(points, vertices, boundary=None,
                         conserved_quantities =\
                         ['stage', 'xmomentum', 'ymomentum'],
@@ -453,5 +438,5 @@
 
 
-        domain = Domain(points, vertices, boundary=None,
+        domain = Generic_Domain(points, vertices, boundary=None,
                         conserved_quantities =\
                         ['stage', 'xmomentum', 'ymomentum'],
@@ -497,5 +482,5 @@
         points = [a, b, c]
         vertices = [ [0,1,2] ]
-        domain = Domain(points, vertices)
+        domain = Generic_Domain(points, vertices)
 
         domain.set_boundary( {default_boundary_tag: Dirichlet_boundary([5,2,1])} )
@@ -528,5 +513,5 @@
 
 
-        domain = Domain(points, vertices, boundary,
+        domain = Generic_Domain(points, vertices, boundary,
                         conserved_quantities =\
                         ['stage', 'xmomentum', 'ymomentum'])
@@ -584,5 +569,5 @@
  
         try:
-            domain = Domain(points, vertices, boundary,
+            domain = Generic_Domain(points, vertices, boundary,
                             conserved_quantities = ['stage', 'xmomentum', 'ymomentum'],
                             evolved_quantities =\
@@ -595,5 +580,5 @@
 
 
-        domain = Domain(points, vertices, boundary,
+        domain = Generic_Domain(points, vertices, boundary,
                         conserved_quantities = ['stage', 'xmomentum', 'ymomentum'],
                         evolved_quantities =\
@@ -688,5 +673,5 @@
 
 
-        domain = Domain(points, vertices, boundary,
+        domain = Generic_Domain(points, vertices, boundary,
                         conserved_quantities =\
                         ['stage', 'xmomentum', 'ymomentum'])
@@ -739,5 +724,5 @@
 
 
-        domain = Domain(points, vertices, boundary,
+        domain = Generic_Domain(points, vertices, boundary,
                         conserved_quantities =\
                         ['stage', 'xmomentum', 'ymomentum'])
@@ -799,5 +784,5 @@
                      (3, 2): 'Third'}
 
-        domain = Domain(points, vertices, boundary,
+        domain = Generic_Domain(points, vertices, boundary,
                         conserved_quantities =\
                         ['stage', 'xmomentum', 'ymomentum'])
@@ -833,119 +818,4 @@
                         'set region failed')
 
-
-    def test_track_speeds(self):
-        """
-        get values based on triangle lists.
-        """
-        from mesh_factory import rectangular
-        from shallow_water import Domain
-
-        #Create basic mesh
-        points, vertices, boundary = rectangular(1, 3)
-
-        #Create shallow water domain
-        domain = Domain(points, vertices, boundary)
-        domain.timestepping_statistics(track_speeds=True)
-
-
-
-    def test_region_tags(self):
-        """
-        get values based on triangle lists.
-        """
-        from mesh_factory import rectangular
-        from shallow_water import Domain
-
-        #Create basic mesh
-        points, vertices, boundary = rectangular(1, 3)
-
-        #Create shallow water domain
-        domain = Domain(points, vertices, boundary)
-        domain.build_tagged_elements_dictionary({'bottom':[0,1],
-                                                 'top':[4,5],
-                                                 'all':[0,1,2,3,4,5]})
-
-
-        #Set friction
-        manning = 0.07
-        domain.set_quantity('friction', manning)
-
-        domain.set_region([set_bottom_friction, set_top_friction])
-        assert num.allclose(domain.quantities['friction'].get_values(),\
-                            [[ 0.09,  0.09,  0.09],
-                             [ 0.09,  0.09,  0.09],
-                             [ 0.07,  0.07,  0.07],
-                             [ 0.07,  0.07,  0.07],
-                             [ 1.0,  1.0,  1.0],
-                             [ 1.0,  1.0,  1.0]])
-
-        domain.set_region([set_all_friction])
-        assert num.allclose(domain.quantities['friction'].get_values(),
-                            [[ 10.09, 10.09, 10.09],
-                             [ 10.09, 10.09, 10.09],
-                             [ 10.07, 10.07, 10.07],
-                             [ 10.07, 10.07, 10.07],
-                             [ 11.0,  11.0,  11.0],
-                             [ 11.0,  11.0,  11.0]])
-
-
-    def test_region_tags2(self):
-        """
-        get values based on triangle lists.
-        """
-        from mesh_factory import rectangular
-        from shallow_water import Domain
-
-        #Create basic mesh
-        points, vertices, boundary = rectangular(1, 3)
-
-        #Create shallow water domain
-        domain = Domain(points, vertices, boundary)
-        domain.build_tagged_elements_dictionary({'bottom':[0,1],
-                                                 'top':[4,5],
-                                                 'all':[0,1,2,3,4,5]})
-
-
-        #Set friction
-        manning = 0.07
-        domain.set_quantity('friction', manning)
-
-        domain.set_region('top', 'friction', 1.0)
-        domain.set_region('bottom', 'friction', 0.09)
-        
-        msg = ("domain.quantities['friction'].get_values()=\n%s\n"
-               'should equal\n'
-               '[[ 0.09,  0.09,  0.09],\n'
-               ' [ 0.09,  0.09,  0.09],\n'
-               ' [ 0.07,  0.07,  0.07],\n'
-               ' [ 0.07,  0.07,  0.07],\n'
-               ' [ 1.0,  1.0,  1.0],\n'
-               ' [ 1.0,  1.0,  1.0]]'
-               % str(domain.quantities['friction'].get_values()))
-        assert num.allclose(domain.quantities['friction'].get_values(),
-                            [[ 0.09,  0.09,  0.09],
-                             [ 0.09,  0.09,  0.09],
-                             [ 0.07,  0.07,  0.07],
-                             [ 0.07,  0.07,  0.07],
-                             [ 1.0,  1.0,  1.0],
-                             [ 1.0,  1.0,  1.0]]), msg
-        
-        domain.set_region([set_bottom_friction, set_top_friction])
-        assert num.allclose(domain.quantities['friction'].get_values(),
-                            [[ 0.09,  0.09,  0.09],
-                             [ 0.09,  0.09,  0.09],
-                             [ 0.07,  0.07,  0.07],
-                             [ 0.07,  0.07,  0.07],
-                             [ 1.0,  1.0,  1.0],
-                             [ 1.0,  1.0,  1.0]])
-
-        domain.set_region([set_all_friction])
-        assert num.allclose(domain.quantities['friction'].get_values(),
-                            [[ 10.09, 10.09, 10.09],
-                             [ 10.09, 10.09, 10.09],
-                             [ 10.07, 10.07, 10.07],
-                             [ 10.07, 10.07, 10.07],
-                             [ 11.0,  11.0,  11.0],
-                             [ 11.0,  11.0,  11.0]])
                              
     def test_rectangular_periodic_and_ghosts(self):
@@ -962,5 +832,5 @@
 
         conserved_quantities = ['quant1', 'quant2']
-        domain = Domain(points, vertices, boundary, conserved_quantities,
+        domain = Generic_Domain(points, vertices, boundary, conserved_quantities,
                         full_send_dict=full_send_dict,
                         ghost_recv_dict=ghost_recv_dict)
Index: /anuga_core/source/anuga/abstract_2d_finite_volumes/test_generic_boundary_conditions.py
===================================================================
--- /anuga_core/source/anuga/abstract_2d_finite_volumes/test_generic_boundary_conditions.py	(revision 7736)
+++ /anuga_core/source/anuga/abstract_2d_finite_volumes/test_generic_boundary_conditions.py	(revision 7737)
@@ -5,5 +5,5 @@
 
 from generic_boundary_conditions import *
-from anuga.abstract_2d_finite_volumes.domain import Domain
+from anuga.abstract_2d_finite_volumes.generic_domain import Generic_Domain
 from anuga.config import epsilon
 
@@ -64,5 +64,5 @@
         elements = [ [1,0,2], [1,2,4], [4,2,5], [3,1,4] ]
 
-        domain = Domain(points, elements)
+        domain = Generic_Domain(points, elements)
         domain.check_integrity()
 
@@ -130,5 +130,5 @@
         elements = [ [1,0,2], [1,2,4], [4,2,5], [3,1,4] ]
 
-        domain = Domain(points, elements)
+        domain = Generic_Domain(points, elements)
         domain.check_integrity()
 
@@ -202,5 +202,5 @@
         elements = [ [1,0,2], [1,2,4], [4,2,5], [3,1,4] ]
 
-        domain = Domain(points, elements)
+        domain = Generic_Domain(points, elements)
         domain.check_integrity()
 
@@ -281,5 +281,5 @@
         elements = [ [1,0,2], [1,2,4], [4,2,5], [3,1,4] ]
 
-        domain = Domain(points, elements)
+        domain = Generic_Domain(points, elements)
         domain.conserved_quantities = ['stage', 'ymomentum']
         domain.quantities['stage'] =\
@@ -374,5 +374,5 @@
         elements = [ [1,0,2], [1,2,4], [4,2,5], [3,1,4] ]
 
-        domain = Domain(points, elements)
+        domain = Generic_Domain(points, elements)
         domain.conserved_quantities = ['stage', 'xmomentum', 'ymomentum']
         domain.evolved_quantities = ['stage', 'xmomentum', 'ymomentum']
Index: /anuga_core/source/anuga/abstract_2d_finite_volumes/test_ghost.py
===================================================================
--- /anuga_core/source/anuga/abstract_2d_finite_volumes/test_ghost.py	(revision 7736)
+++ /anuga_core/source/anuga/abstract_2d_finite_volumes/test_ghost.py	(revision 7737)
@@ -4,5 +4,5 @@
 from math import sqrt
 
-from anuga.abstract_2d_finite_volumes.domain import *
+from anuga.abstract_2d_finite_volumes.generic_domain import Generic_Domain
 from anuga.config import epsilon
 
@@ -34,5 +34,5 @@
         other_quantities = ['elevation', 'friction']
 
-        domain = Domain(points, vertices, None,
+        domain = Generic_Domain(points, vertices, None,
                         conserved_quantities, None, other_quantities)
         domain.check_integrity()
Index: /anuga_core/source/anuga/abstract_2d_finite_volumes/test_pmesh2domain.py
===================================================================
--- /anuga_core/source/anuga/abstract_2d_finite_volumes/test_pmesh2domain.py	(revision 7736)
+++ /anuga_core/source/anuga/abstract_2d_finite_volumes/test_pmesh2domain.py	(revision 7737)
@@ -4,10 +4,9 @@
 import unittest
 
-#from anuga.pyvolution.pmesh2domain import *
 from pmesh2domain import *
 
-from anuga.shallow_water import Domain,\
-     Reflective_boundary, Dirichlet_boundary,\
-     Transmissive_boundary
+from anuga.shallow_water.shallow_water_domain import Domain
+from anuga.abstract_2d_finite_volumes.generic_boundary_conditions \
+                        import Dirichlet_boundary
 
 from anuga.coordinate_transforms.geo_reference import Geo_reference
@@ -167,5 +166,5 @@
          tags["3"] = b3
 
-         domain = pmesh_instance_to_domain_instance(mesh_instance, Domain)
+         domain = pmesh_to_domain_instance(mesh_instance, Domain)
 
          os.remove(fileName)
Index: /anuga_core/source/anuga/abstract_2d_finite_volumes/test_quantity.py
===================================================================
--- /anuga_core/source/anuga/abstract_2d_finite_volumes/test_quantity.py	(revision 7736)
+++ /anuga_core/source/anuga/abstract_2d_finite_volumes/test_quantity.py	(revision 7737)
@@ -10,5 +10,6 @@
 from anuga.fit_interpolate.fit import fit_to_mesh
 #from anuga.pyvolution.least_squares import fit_to_mesh         
-from anuga.abstract_2d_finite_volumes.domain import Domain
+from anuga.abstract_2d_finite_volumes.generic_domain \
+                import Generic_Domain
 from anuga.geospatial_data.geospatial_data import Geospatial_data
 from anuga.coordinate_transforms.geo_reference import Geo_reference
@@ -39,5 +40,5 @@
         elements = [ [1,0,2], [1,2,4], [4,2,5], [3,1,4] ]
 
-        self.mesh1 = Domain(points[:3], [elements[0]])
+        self.mesh1 = Generic_Domain(points[:3], [elements[0]])
         self.mesh1.check_integrity()
         
@@ -45,5 +46,5 @@
         #print isinstance(self.mesh1, Domain)
 
-        self.mesh4 = Domain(points, elements)
+        self.mesh4 = Generic_Domain(points, elements)
         self.mesh4.check_integrity()
 
@@ -56,5 +57,5 @@
         elements = [[0,2,1]]
         
-        self.mesh_onslow = Domain(points, elements)
+        self.mesh_onslow = Generic_Domain(points, elements)
         self.mesh_onslow.check_integrity()
         
@@ -174,5 +175,5 @@
         vertices = [[1,0,2], [1,2,4], [4,2,5], [3,1,4]]
 
-        domain = Domain(points, vertices)
+        domain = Generic_Domain(points, vertices)
 
         quantity = Quantity(domain)
@@ -575,5 +576,5 @@
 
         mesh_georef = Geo_reference(56,-0.76,-0.76)
-        mesh1 = Domain(vertex_coordinates, triangles,
+        mesh1 = Generic_Domain(vertex_coordinates, triangles,
                        geo_reference = mesh_georef)
         mesh1.check_integrity()
@@ -1087,5 +1088,5 @@
 
         #absolute going in ..
-        mesh4 = Domain(points, elements,
+        mesh4 = Generic_Domain(points, elements,
                        geo_reference = Geo_reference(56, 0, 0))
         mesh4.check_integrity()
@@ -1167,5 +1168,5 @@
         elements = [ [1,0,2], [1,2,4], [4,2,5], [3,1,4] ]
 
-        mesh4 = Domain(points, elements,
+        mesh4 = Generic_Domain(points, elements,
                        geo_reference = Geo_reference(56, x0, y0))
         mesh4.check_integrity()
@@ -1875,167 +1876,7 @@
 
 
-
-    #Test smoothing
-    def test_smoothing(self):
+    def set_array_values_by_index(self):
 
         from mesh_factory import rectangular
-        from shallow_water import Domain, Transmissive_boundary
-        from anuga.utilities.numerical_tools import mean
-
-        #Create basic mesh
-        points, vertices, boundary = rectangular(2, 2)
-
-        #Create shallow water domain
-        domain = Domain(points, vertices, boundary)
-        domain.default_order=2
-        domain.reduction = mean
-
-
-        #Set some field values
-        domain.set_quantity('elevation', lambda x,y: x)
-        domain.set_quantity('friction', 0.03)
-
-
-        ######################
-        # Boundary conditions
-        B = Transmissive_boundary(domain)
-        domain.set_boundary( {'left': B, 'right': B, 'top': B, 'bottom': B})
-
-
-        ######################
-        #Initial condition - with jumps
-
-        bed = domain.quantities['elevation'].vertex_values
-        stage = num.zeros(bed.shape, num.float)
-
-        h = 0.03
-        for i in range(stage.shape[0]):
-            if i % 2 == 0:
-                stage[i,:] = bed[i,:] + h
-            else:
-                stage[i,:] = bed[i,:]
-
-        domain.set_quantity('stage', stage)
-
-        stage = domain.quantities['stage']
-
-        #Get smoothed stage
-        A, V = stage.get_vertex_values(xy=False, smooth=True)
-        Q = stage.vertex_values
-
-
-        assert A.shape[0] == 9
-        assert V.shape[0] == 8
-        assert V.shape[1] == 3
-
-        #First four points
-        assert num.allclose(A[0], (Q[0,2] + Q[1,1])/2)
-        assert num.allclose(A[1], (Q[1,0] + Q[3,1] + Q[2,2])/3)
-        assert num.allclose(A[2], Q[3,0])
-        assert num.allclose(A[3], (Q[0,0] + Q[5,1] + Q[4,2])/3)
-
-        #Center point
-        assert num.allclose(A[4], (Q[0,1] + Q[1,2] + Q[2,0] +\
-                                   Q[5,0] + Q[6,2] + Q[7,1])/6)
-
-
-        #Check V
-        assert num.allclose(V[0,:], [3,4,0])
-        assert num.allclose(V[1,:], [1,0,4])
-        assert num.allclose(V[2,:], [4,5,1])
-        assert num.allclose(V[3,:], [2,1,5])
-        assert num.allclose(V[4,:], [6,7,3])
-        assert num.allclose(V[5,:], [4,3,7])
-        assert num.allclose(V[6,:], [7,8,4])
-        assert num.allclose(V[7,:], [5,4,8])
-
-        #Get smoothed stage with XY
-        X, Y, A1, V1 = stage.get_vertex_values(xy=True, smooth=True)
-
-        assert num.allclose(A, A1)
-        assert num.allclose(V, V1)
-
-        #Check XY
-        assert num.allclose(X[4], 0.5)
-        assert num.allclose(Y[4], 0.5)
-
-        assert num.allclose(X[7], 1.0)
-        assert num.allclose(Y[7], 0.5)
-
-
-
-
-    def test_vertex_values_no_smoothing(self):
-
-        from mesh_factory import rectangular
-        from shallow_water import Domain, Transmissive_boundary
-        from anuga.utilities.numerical_tools import mean
-
-
-        #Create basic mesh
-        points, vertices, boundary = rectangular(2, 2)
-
-        #Create shallow water domain
-        domain = Domain(points, vertices, boundary)
-        domain.default_order=2
-        domain.reduction = mean
-
-
-        #Set some field values
-        domain.set_quantity('elevation', lambda x,y: x)
-        domain.set_quantity('friction', 0.03)
-
-
-        ######################
-        #Initial condition - with jumps
-
-        bed = domain.quantities['elevation'].vertex_values
-        stage = num.zeros(bed.shape, num.float)
-
-        h = 0.03
-        for i in range(stage.shape[0]):
-            if i % 2 == 0:
-                stage[i,:] = bed[i,:] + h
-            else:
-                stage[i,:] = bed[i,:]
-
-        domain.set_quantity('stage', stage)
-
-        #Get stage
-        stage = domain.quantities['stage']
-        A, V = stage.get_vertex_values(xy=False, smooth=False)
-        Q = stage.vertex_values.flatten()
-
-        for k in range(8):
-            assert num.allclose(A[k], Q[k])
-
-
-        for k in range(8):
-            assert V[k, 0] == 3*k
-            assert V[k, 1] == 3*k+1
-            assert V[k, 2] == 3*k+2
-
-
-
-        X, Y, A1, V1 = stage.get_vertex_values(xy=True, smooth=False)
-
-
-        assert num.allclose(A, A1)
-        assert num.allclose(V, V1)
-
-        #Check XY
-        assert num.allclose(X[1], 0.5)
-        assert num.allclose(Y[1], 0.5)
-        assert num.allclose(X[4], 0.0)
-        assert num.allclose(Y[4], 0.0)
-        assert num.allclose(X[12], 1.0)
-        assert num.allclose(Y[12], 0.0)
-
-
-
-    def set_array_values_by_index(self):
-
-        from mesh_factory import rectangular
-        from shallow_water import Domain
 
         #Create basic mesh
@@ -2043,5 +1884,5 @@
 
         #Create shallow water domain
-        domain = Domain(points, vertices, boundary)
+        domain = Generic_Domain(points, vertices, boundary)
         #print "domain.number_of_elements ",domain.number_of_elements
         quantity = Quantity(domain,[[1,1,1],[2,2,2]])
@@ -2066,5 +1907,4 @@
         """
         from mesh_factory import rectangular
-        from shallow_water import Domain
 
         #Create basic mesh
@@ -2072,5 +1912,5 @@
         #print "vertices",vertices
         #Create shallow water domain
-        domain = Domain(points, vertices, boundary)
+        domain = Generic_Domain(points, vertices, boundary)
         #print "domain.number_of_elements ",domain.number_of_elements
         quantity = Quantity(domain,[[1,1,1],[2,2,2],[3,3,3],
@@ -2152,5 +1992,4 @@
         """
         from mesh_factory import rectangular
-        from shallow_water import Domain
 
         #Create basic mesh
@@ -2158,5 +1997,5 @@
         #print "vertices",vertices
         #Create shallow water domain
-        domain = Domain(points, vertices, boundary)
+        domain = Generic_Domain(points, vertices, boundary)
         #print "domain.number_of_elements ",domain.number_of_elements
         quantity = Quantity(domain,[[0,0,0],[1,1,1],[2,2,2],[3,3,3],
@@ -2178,5 +2017,4 @@
         """
         from mesh_factory import rectangular
-        from shallow_water import Domain
 
         #Create basic mesh
@@ -2188,5 +2026,5 @@
 
         #Create shallow water domain
-        domain = Domain(points, vertices, boundary)
+        domain = Generic_Domain(points, vertices, boundary)
         #print "domain.number_of_elements ",domain.number_of_elements
         quantity = Quantity(domain,[[0,0,0],[1,1,1],[2,2,2],[3,3,3],
@@ -2232,5 +2070,5 @@
         vertices = [ [1,0,2], [1,2,4], [4,2,5], [3,1,4]]
 
-        domain = Domain(points, vertices)
+        domain = Generic_Domain(points, vertices)
 
         quantity = Quantity(domain)
@@ -2280,9 +2118,8 @@
 
         from mesh_factory import rectangular
-        from shallow_water import Domain
 
         #Create basic mesh
         points, vertices, boundary = rectangular(1, 3)
-        domain = Domain(points, vertices, boundary)
+        domain = Generic_Domain(points, vertices, boundary)
 
         #Constant values
@@ -2338,5 +2175,5 @@
         vertices = [[1,0,2], [1,2,4], [4,2,5], [3,1,4]]
 
-        domain = Domain(points, vertices)
+        domain = Generic_Domain(points, vertices)
 
         quantity = Quantity(domain)
@@ -2372,5 +2209,5 @@
         vertices = [[1,0,2], [1,2,4], [4,2,5], [3,1,4]]
 
-        domain = Domain(points, vertices,
+        domain = Generic_Domain(points, vertices,
                         geo_reference=Geo_reference(zone,xllcorner,yllcorner))
 
@@ -2416,5 +2253,4 @@
         """
         from mesh_factory import rectangular
-        from shallow_water import Domain
 
         #Create basic mesh
@@ -2426,5 +2262,5 @@
 
         #Create shallow water domain
-        domain = Domain(points, vertices, boundary)
+        domain = Generic_Domain(points, vertices, boundary)
         #print "domain.number_of_elements ",domain.number_of_elements
         quantity = Quantity(domain,[[1,1,1],[2,2,2],[3,3,3],
@@ -2473,5 +2309,5 @@
         """
         from mesh_factory import rectangular
-        from shallow_water import Domain
+      #  from anuga.shallow_water.shallow_water_domain import Domain
 
         #Create basic mesh
@@ -2483,5 +2319,5 @@
 
         #Create shallow water domain
-        domain = Domain(points, vertices, boundary)
+        domain = Generic_Domain(points, vertices, boundary)
         #print "domain.number_of_elements ",domain.number_of_elements
         quantity = Quantity(domain,[[0,0,0],[1,1,1],[2,2,2],[3,3,3],
Index: /anuga_core/source/anuga/abstract_2d_finite_volumes/test_region.py
===================================================================
--- /anuga_core/source/anuga/abstract_2d_finite_volumes/test_region.py	(revision 7736)
+++ /anuga_core/source/anuga/abstract_2d_finite_volumes/test_region.py	(revision 7737)
@@ -4,5 +4,5 @@
 from math import sqrt
 
-from domain import *
+from generic_domain import Generic_Domain
 from region import *
 #from anuga.config import epsilon
